
(*
 * lenHelp : int list * int -> int
 * REQUIRES: true
 * ENSURES: lenHelp (lst,acc) ==> acc + the length of lst
 *)
fun lenHelp (lst:int list, acc:int) : int = 
  (case lst of 
      [] => acc 
    | _::tl => lenHelp (tl, acc + 1)
  )


(*
 * lenT : int list -> int
 * REQUIRES: true
 * ENSURES: lenT lst ==> the length of lst
 *)
fun lenT (lst:int list) : int = 
  lenHelp (lst, 0)


val 0 = lenT [] 
val 1 = lenT [1]
val 2 = lenT (1::2::[])