

(*
 * revAppend : int list * int list -> int list
 * REQUIRES: true
 * ENSURES: revAppend (a,b) ==> a list of all the elements of a in reverse 
 *  order followed by those of b in the same order as b
 *)
fun revAppend (lst:int list, acc:int list) : int list = 
  (case lst of 
      [] => acc 
    | hd::tl => revAppend (tl, hd::acc)
  )


(*
 * revT : int list -> int list
 * REQUIRES: true
 * ENSURES: revT x ==> a list of all the elments of x in reverse order
 *)
fun revT (lst:int list) : int list = revAppend (lst, [])
